/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#ifndef ARDUINOPLC32_H_
#define ARDUINOPLC32_H_

#include "sc_types.h"
#include "StatemachineInterface.h"
#include "TimedStatemachineInterface.h"

/*! \file Header of the state machine 'arduinoPLC32'.
*/

class ArduinoPLC32 : public TimedStatemachineInterface, public StatemachineInterface
{
	
	public:
		
		ArduinoPLC32();
		
		~ArduinoPLC32();
		
		/*! Enumeration of all states */ 
		typedef enum
		{
			main_region_State10,
			main_region_State11,
			main_region_State11_r1_State21,
			main_region_State11_r1_State20,
			main_region_State11_r2_State0,
			main_region_State11_r2_State1,
			main_region_State11_r2_State2,
			main_region_State11_r2_State3,
			main_region_State11_r2_State4,
			main_region_State11_r2_State5,
			ArduinoPLC32_last_state
		} ArduinoPLC32States;
		
		//! Inner class for default interface scope.
		class DefaultSCI
		{
			
			public:
				/*! Gets the value of the variable 'BPATU' that is defined in the default interface scope. */
				sc_integer get_bPATU();
				
				/*! Sets the value of the variable 'BPATU' that is defined in the default interface scope. */
				void set_bPATU(sc_integer value);
				
				/*! Raises the in event 'DCY' that is defined in the default interface scope. */
				void raise_dCY();
				
				/*! Raises the in event 'FCY' that is defined in the default interface scope. */
				void raise_fCY();
				
				/*! Gets the value of the variable 'AUTO' that is defined in the default interface scope. */
				sc_integer get_aUTO();
				
				/*! Sets the value of the variable 'AUTO' that is defined in the default interface scope. */
				void set_aUTO(sc_integer value);
				
				/*! Gets the value of the variable 'M' that is defined in the default interface scope. */
				sc_boolean get_m();
				
				/*! Sets the value of the variable 'M' that is defined in the default interface scope. */
				void set_m(sc_boolean value);
				
				/*! Gets the value of the variable 'a1A1' that is defined in the default interface scope. */
				sc_boolean get_a1A1();
				
				/*! Sets the value of the variable 'a1A1' that is defined in the default interface scope. */
				void set_a1A1(sc_boolean value);
				
				/*! Gets the value of the variable 'a1B1' that is defined in the default interface scope. */
				sc_boolean get_a1B1();
				
				/*! Sets the value of the variable 'a1B1' that is defined in the default interface scope. */
				void set_a1B1(sc_boolean value);
				
				/*! Gets the value of the variable 'a2A1' that is defined in the default interface scope. */
				sc_boolean get_a2A1();
				
				/*! Sets the value of the variable 'a2A1' that is defined in the default interface scope. */
				void set_a2A1(sc_boolean value);
				
				/*! Gets the value of the variable 'a2B1' that is defined in the default interface scope. */
				sc_boolean get_a2B1();
				
				/*! Sets the value of the variable 'a2B1' that is defined in the default interface scope. */
				void set_a2B1(sc_boolean value);
				
				/*! Raises the in event 'a1A6' that is defined in the default interface scope. */
				void raise_a1A6();
				
				/*! Raises the in event 'a1B6' that is defined in the default interface scope. */
				void raise_a1B6();
				
				/*! Raises the in event 'a2A6' that is defined in the default interface scope. */
				void raise_a2A6();
				
				/*! Raises the in event 'a2B6' that is defined in the default interface scope. */
				void raise_a2B6();
				
				/*! Gets the value of the variable 'potA0' that is defined in the default interface scope. */
				sc_integer get_potA0();
				
				/*! Sets the value of the variable 'potA0' that is defined in the default interface scope. */
				void set_potA0(sc_integer value);
				
				/*! Gets the value of the variable 'potA1' that is defined in the default interface scope. */
				sc_integer get_potA1();
				
				/*! Sets the value of the variable 'potA1' that is defined in the default interface scope. */
				void set_potA1(sc_integer value);
				
				/*! Gets the value of the variable 'analogout1' that is defined in the default interface scope. */
				sc_integer get_analogout1();
				
				/*! Sets the value of the variable 'analogout1' that is defined in the default interface scope. */
				void set_analogout1(sc_integer value);
				
				/*! Gets the value of the variable 'analogout2' that is defined in the default interface scope. */
				sc_integer get_analogout2();
				
				/*! Sets the value of the variable 'analogout2' that is defined in the default interface scope. */
				void set_analogout2(sc_integer value);
				
				
			private:
				friend class ArduinoPLC32;
				sc_integer BPATU;
				sc_boolean DCY_raised;
				sc_boolean FCY_raised;
				sc_integer AUTO_ID;
				sc_boolean M;
				sc_boolean a1A1;
				sc_boolean a1B1;
				sc_boolean a2A1;
				sc_boolean a2B1;
				sc_boolean a1A6_raised;
				sc_boolean a1B6_raised;
				sc_boolean a2A6_raised;
				sc_boolean a2B6_raised;
				sc_integer potA0;
				sc_integer potA1;
				sc_integer analogout1;
				sc_integer analogout2;
		};
				
		
		/*! Returns an instance of the interface class 'DefaultSCI'. */
		DefaultSCI* getDefaultSCI();
		
		/*! Gets the value of the variable 'BPATU' that is defined in the default interface scope. */
		sc_integer get_bPATU();
		
		/*! Sets the value of the variable 'BPATU' that is defined in the default interface scope. */
		void set_bPATU(sc_integer value);
		
		/*! Raises the in event 'DCY' that is defined in the default interface scope. */
		void raise_dCY();
		
		/*! Raises the in event 'FCY' that is defined in the default interface scope. */
		void raise_fCY();
		
		/*! Gets the value of the variable 'AUTO' that is defined in the default interface scope. */
		sc_integer get_aUTO();
		
		/*! Sets the value of the variable 'AUTO' that is defined in the default interface scope. */
		void set_aUTO(sc_integer value);
		
		/*! Gets the value of the variable 'M' that is defined in the default interface scope. */
		sc_boolean get_m();
		
		/*! Sets the value of the variable 'M' that is defined in the default interface scope. */
		void set_m(sc_boolean value);
		
		/*! Gets the value of the variable 'a1A1' that is defined in the default interface scope. */
		sc_boolean get_a1A1();
		
		/*! Sets the value of the variable 'a1A1' that is defined in the default interface scope. */
		void set_a1A1(sc_boolean value);
		
		/*! Gets the value of the variable 'a1B1' that is defined in the default interface scope. */
		sc_boolean get_a1B1();
		
		/*! Sets the value of the variable 'a1B1' that is defined in the default interface scope. */
		void set_a1B1(sc_boolean value);
		
		/*! Gets the value of the variable 'a2A1' that is defined in the default interface scope. */
		sc_boolean get_a2A1();
		
		/*! Sets the value of the variable 'a2A1' that is defined in the default interface scope. */
		void set_a2A1(sc_boolean value);
		
		/*! Gets the value of the variable 'a2B1' that is defined in the default interface scope. */
		sc_boolean get_a2B1();
		
		/*! Sets the value of the variable 'a2B1' that is defined in the default interface scope. */
		void set_a2B1(sc_boolean value);
		
		/*! Raises the in event 'a1A6' that is defined in the default interface scope. */
		void raise_a1A6();
		
		/*! Raises the in event 'a1B6' that is defined in the default interface scope. */
		void raise_a1B6();
		
		/*! Raises the in event 'a2A6' that is defined in the default interface scope. */
		void raise_a2A6();
		
		/*! Raises the in event 'a2B6' that is defined in the default interface scope. */
		void raise_a2B6();
		
		/*! Gets the value of the variable 'potA0' that is defined in the default interface scope. */
		sc_integer get_potA0();
		
		/*! Sets the value of the variable 'potA0' that is defined in the default interface scope. */
		void set_potA0(sc_integer value);
		
		/*! Gets the value of the variable 'potA1' that is defined in the default interface scope. */
		sc_integer get_potA1();
		
		/*! Sets the value of the variable 'potA1' that is defined in the default interface scope. */
		void set_potA1(sc_integer value);
		
		/*! Gets the value of the variable 'analogout1' that is defined in the default interface scope. */
		sc_integer get_analogout1();
		
		/*! Sets the value of the variable 'analogout1' that is defined in the default interface scope. */
		void set_analogout1(sc_integer value);
		
		/*! Gets the value of the variable 'analogout2' that is defined in the default interface scope. */
		sc_integer get_analogout2();
		
		/*! Sets the value of the variable 'analogout2' that is defined in the default interface scope. */
		void set_analogout2(sc_integer value);
		
		
		void init();
		
		void enter();
		
		void exit();
		
		void runCycle();
		
		/*!
		* Checks if the state machine is active (until 2.4.1 this method was used for states).
		* A state machine is active if it has been entered. It is inactive if it has not been entered at all or if it has been exited.
		*/
		sc_boolean isActive();
		
		
		/*!
		* Checks if all active states are final. 
		* If there are no active states then the state machine is considered being inactive. In this case this method returns false.
		*/
		sc_boolean isFinal();
		
		void setTimer(TimerInterface* timer);
		
		TimerInterface* getTimer();
		
		void raiseTimeEvent(sc_eventid event);
		
		/*! Checks if the specified state is active (until 2.4.1 the used method for states was calles isActive()). */
		sc_boolean isStateActive(ArduinoPLC32States state);
	
	private:
	
	
		//! the maximum number of orthogonal states defines the dimension of the state configuration vector.
		static const sc_integer maxOrthogonalStates = 2;
		
		//! number of time events used by the state machine.
		static const sc_integer timeEventsCount = 5;
		TimerInterface* timer;
		sc_boolean timeEvents[timeEventsCount];
		
		ArduinoPLC32States stateConfVector[maxOrthogonalStates];
		
		sc_ushort stateConfVectorPosition;
		
		DefaultSCI iface;
		
		// prototypes of all internal functions
		
		sc_boolean check_main_region_State10_tr0_tr0();
		sc_boolean check_main_region_State10_lr0_lr0();
		sc_boolean check_main_region_State10_lr1_lr1();
		sc_boolean check_main_region_State10_lr2_lr2();
		sc_boolean check_main_region_State10_lr3_lr3();
		sc_boolean check_main_region_State10_lr4_lr4();
		sc_boolean check_main_region_State10_lr5_lr5();
		sc_boolean check_main_region_State10_lr6_lr6();
		sc_boolean check_main_region_State11_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State21_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State21_lr0_lr0();
		sc_boolean check_main_region_State11_r1_State21_lr1_lr1();
		sc_boolean check_main_region_State11_r1_State21_lr2_lr2();
		sc_boolean check_main_region_State11_r1_State20_tr0_tr0();
		sc_boolean check_main_region_State11_r1_State20_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State0_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State0_tr1_tr1();
		sc_boolean check_main_region_State11_r2_State0_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State1_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State1_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State1_lr1_lr1();
		sc_boolean check_main_region_State11_r2_State2_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State2_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State2_lr1_lr1();
		sc_boolean check_main_region_State11_r2_State3_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State3_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State3_lr1_lr1();
		sc_boolean check_main_region_State11_r2_State4_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State4_tr1_tr1();
		sc_boolean check_main_region_State11_r2_State4_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State4_lr1_lr1();
		sc_boolean check_main_region_State11_r2_State5_tr0_tr0();
		sc_boolean check_main_region_State11_r2_State5_lr0_lr0();
		sc_boolean check_main_region_State11_r2_State5_lr1_lr1();
		sc_boolean check_main_region_State11_r2_State5_lr2_lr2();
		sc_boolean check_main_region_State11_r2_State5_lr3_lr3();
		void effect_main_region_State10_tr0();
		void effect_main_region_State10_lr0_lr0();
		void effect_main_region_State10_lr1_lr1();
		void effect_main_region_State10_lr2_lr2();
		void effect_main_region_State10_lr3_lr3();
		void effect_main_region_State10_lr4_lr4();
		void effect_main_region_State10_lr5_lr5();
		void effect_main_region_State10_lr6_lr6();
		void effect_main_region_State11_tr0();
		void effect_main_region_State11_r1_State21_tr0();
		void effect_main_region_State11_r1_State21_lr0_lr0();
		void effect_main_region_State11_r1_State21_lr1_lr1();
		void effect_main_region_State11_r1_State21_lr2_lr2();
		void effect_main_region_State11_r1_State20_tr0();
		void effect_main_region_State11_r1_State20_lr0_lr0();
		void effect_main_region_State11_r2_State0_tr0();
		void effect_main_region_State11_r2_State0_tr1();
		void effect_main_region_State11_r2_State0_lr0_lr0();
		void effect_main_region_State11_r2_State1_tr0();
		void effect_main_region_State11_r2_State1_lr0_lr0();
		void effect_main_region_State11_r2_State1_lr1_lr1();
		void effect_main_region_State11_r2_State2_tr0();
		void effect_main_region_State11_r2_State2_lr0_lr0();
		void effect_main_region_State11_r2_State2_lr1_lr1();
		void effect_main_region_State11_r2_State3_tr0();
		void effect_main_region_State11_r2_State3_lr0_lr0();
		void effect_main_region_State11_r2_State3_lr1_lr1();
		void effect_main_region_State11_r2_State4_tr0();
		void effect_main_region_State11_r2_State4_tr1();
		void effect_main_region_State11_r2_State4_lr0_lr0();
		void effect_main_region_State11_r2_State4_lr1_lr1();
		void effect_main_region_State11_r2_State5_tr0();
		void effect_main_region_State11_r2_State5_lr0_lr0();
		void effect_main_region_State11_r2_State5_lr1_lr1();
		void effect_main_region_State11_r2_State5_lr2_lr2();
		void effect_main_region_State11_r2_State5_lr3_lr3();
		void enact_main_region_State11_r2_State1();
		void enact_main_region_State11_r2_State2();
		void enact_main_region_State11_r2_State3();
		void enact_main_region_State11_r2_State4();
		void exact_main_region_State11_r2_State1();
		void exact_main_region_State11_r2_State2();
		void exact_main_region_State11_r2_State3();
		void exact_main_region_State11_r2_State4();
		void enseq_main_region_State10_default();
		void enseq_main_region_State11_default();
		void enseq_main_region_State11_r1_State21_default();
		void enseq_main_region_State11_r1_State20_default();
		void enseq_main_region_State11_r2_State0_default();
		void enseq_main_region_State11_r2_State1_default();
		void enseq_main_region_State11_r2_State2_default();
		void enseq_main_region_State11_r2_State3_default();
		void enseq_main_region_State11_r2_State4_default();
		void enseq_main_region_State11_r2_State5_default();
		void enseq_main_region_default();
		void enseq_main_region_State11_r1_default();
		void enseq_main_region_State11_r2_default();
		void exseq_main_region_State10();
		void exseq_main_region_State11();
		void exseq_main_region_State11_r1_State21();
		void exseq_main_region_State11_r1_State20();
		void exseq_main_region_State11_r2_State0();
		void exseq_main_region_State11_r2_State1();
		void exseq_main_region_State11_r2_State2();
		void exseq_main_region_State11_r2_State3();
		void exseq_main_region_State11_r2_State4();
		void exseq_main_region_State11_r2_State5();
		void exseq_main_region();
		void exseq_main_region_State11_r1();
		void exseq_main_region_State11_r2();
		void react_main_region_State10();
		void react_main_region_State11_r1_State21();
		void react_main_region_State11_r1_State20();
		void react_main_region_State11_r2_State0();
		void react_main_region_State11_r2_State1();
		void react_main_region_State11_r2_State2();
		void react_main_region_State11_r2_State3();
		void react_main_region_State11_r2_State4();
		void react_main_region_State11_r2_State5();
		void react_main_region__entry_Default();
		void react_main_region_State11_r1__entry_Default();
		void react_main_region_State11_r2__entry_Default();
		void clearInEvents();
		void clearOutEvents();
		
};
#endif /* ARDUINOPLC32_H_ */
